package cn.com.qmth.examcloud.commons.helpers;

import java.io.Serializable;

import com.alibaba.fastjson.JSONObject;

/**
 * 键值对
 * 
 * @author WANGWEI
 *
 * @param <V>
 */
public class KeyValuePair<K, V> implements Serializable {

	private static final long serialVersionUID = 5140216132754119367L;

	private K key;

	private V value;

	public KeyValuePair(K key, V value) {
		super();
		this.key = key;
		this.value = value;

	}

	public JSONObject toJsonObject(String keyAlias, String valueAlias) {
		JSONObject obj = new JSONObject();
		obj.put(keyAlias, key);
		obj.put(valueAlias, value);
		return obj;
	}

	public K getKey() {
		return key;
	}

	public void setKey(K key) {
		this.key = key;
	}

	public V getValue() {
		return value;
	}

	public void setValue(V value) {
		this.value = value;
	}

}
