package cn.com.qmth.examcloud.commons.helpers.pipeline;

/**
 * 节点
 *
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public interface Node<KEYIN, VALUEIN, KEYOUT, VALUEOUT> {

	/**
	 * 启动
	 *
	 * @author WANGWEI
	 */
	void start();

	/**
	 * 设置下级节点
	 *
	 * @author WANGWEI
	 * @param subNode
	 */
	void setLowerNode(Node<KEYOUT, VALUEOUT, ?, ?> lowerNode);

	/**
	 * 获取下级节点
	 *
	 * @author WANGWEI
	 * @return
	 */
	Node<KEYOUT, VALUEOUT, ?, ?> getLowerNode();

	/**
	 * 获取存储器
	 *
	 * @author WANGWEI
	 * @return
	 */
	Storer<KEYIN, VALUEIN> getStorer();

	/**
	 * 设置是否是首节点
	 *
	 * @author WANGWEI
	 * @param first
	 */
	void setFirst(boolean first);

	/**
	 * 设置循环间隔
	 *
	 * @author WANGWEI
	 * @param sleep
	 */
	void setSleep(int sleep);

}