package cn.com.qmth.examcloud.commons.helpers.pipeline;

import java.util.List;

import cn.com.qmth.examcloud.commons.helpers.KeyValuePair;
import cn.com.qmth.examcloud.commons.helpers.ObjectHolder;

/**
 * 节点执行器
 *
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 * @param <KEYIN>
 * @param <VALUEIN>
 * @param <KEYOUT>
 * @param <VALUEOUT>
 */
public interface NodeExecuter<KEYIN, VALUEIN, KEYOUT, VALUEOUT> {

	/**
	 * 执行
	 *
	 * @author WANGWEI
	 * @param key
	 * @param value
	 * @param outList
	 * @param removable
	 * @param context
	 * @throws Exception
	 */
	void execute(KEYIN key, VALUEIN value, final List<KeyValuePair<KEYOUT, VALUEOUT>> outList,
			final ObjectHolder<Boolean> removable, TaskContext context) throws Exception;

}