package cn.com.qmth.examcloud.commons.helpers.pipeline;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import com.google.common.collect.Maps;

/**
 * 节点存储器
 *
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public class Storer<KEY, VALUE> {

	private Map<KEY, VALUE> MAP = Maps.newConcurrentMap();

	private Map<KEY, VALUE> BUFFER_MAP = Maps.newConcurrentMap();

	public synchronized Set<Entry<KEY, VALUE>> getEntrySet() {
		MAP.putAll(BUFFER_MAP);
		BUFFER_MAP.clear();
		return MAP.entrySet();
	}

	public synchronized void putElement(KEY key, VALUE value) {
		BUFFER_MAP.put(key, value);
	}

	public synchronized boolean isEmpty() {
		return MAP.isEmpty();
	}

	public synchronized void remove(KEY key) {
		MAP.remove(key);
	}

}