package cn.com.qmth.examcloud.commons.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.commons.io.IOUtils;

/**
 * 资源加载器
 *
 * @author WANGWEI
 */
public class ResourceLoader {

	/**
	 * 方法注释
	 *
	 * @author WANGWEI
	 * @param resourceName
	 * @return
	 */
	public static String getResource(String resourceName) {
		InputStream is = null;
		try {
			is = ResourceLoader.class.getClassLoader().getResourceAsStream(resourceName);
			if (null == is) {
				throw new RuntimeException(
						"Resource could not be found. resource name is '" + resourceName + "'.");
			}
			return IOUtils.toString(is, "UTF-8");
		} catch (IOException e) {
			throw new RuntimeException(e);
		} finally {
			IOUtils.closeQuietly(is);
		}
	}

	/**
	 * 方法注释
	 *
	 * @author WANGWEI
	 * @param resourceName
	 * @return
	 */
	public static String getResourceWithoutBlank(String resourceName) {
		InputStream is = null;
		BufferedReader br = null;
		try {
			is = ResourceLoader.class.getClassLoader().getResourceAsStream(resourceName);
			br = new BufferedReader(new InputStreamReader(is, "UTF-8"));
			StringBuilder sb = new StringBuilder();
			String line = null;
			while (null != (line = br.readLine())) {
				sb.append(line.trim());
			}

			return sb.toString();
		} catch (IOException e) {
			throw new RuntimeException(e);
		} finally {
			IOUtils.closeQuietly(br);
			IOUtils.closeQuietly(is);
		}
	}
}