package cn.com.qmth.examcloud.test.pipeline;

import cn.com.qmth.examcloud.commons.helpers.pipeline.Node;
import cn.com.qmth.examcloud.commons.helpers.pipeline.SimpleNode;
import cn.com.qmth.examcloud.commons.helpers.pipeline.TaskContext;

public class Test {

	public static void main(String[] args) {
		TaskContext context = new TaskContext();
		context.put("path", "D:/Temp/test.txt");

		FileReaderExecuter fileReaderExecuter = new FileReaderExecuter();
		PrintExecuter printExecuter = new PrintExecuter();

		Node<String, String, String, String> node1 = new SimpleNode<String, String, String, String>(
				"reader", fileReaderExecuter, context);

		Node<String, String, String, String> node2 = new SimpleNode<String, String, String, String>(
				"print", printExecuter, context);

		node1.setLowerNode(node2);

		node1.setFirst(true);
		node1.setSleep(10);

		node2.setSleep(5);

		node1.start();
		node2.start();
	}

}
