package cn.com.qmth.examcloud.question.commons.core.paper;

import java.io.Serializable;
import java.util.List;

/**
 * 题结构包装器
 *
 * @author WANGWEI
 * @date 2018年8月15日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class DefaultQuestionStructureWrapper implements Serializable {

	private static final long serialVersionUID = 8423916951155451548L;

	/**
	 * 题ID
	 */
	private String questionId;

	/**
	 * 版本号
	 */
	private String version;

	/**
	 * 题分数
	 */
	private Double questionScore;

	/**
	 * 限制播放次数
	 */
	private Integer limitedPlayTimes;

	/**
	 * 已播放次数
	 */
	private Integer playedTimes;

	/**
	 * 作答限时
	 */
	private Long timeLimit;

	/**
	 * 题单元包装器
	 */
	private List<DefaultQuestionUnitWrapper> questionUnitWrapperList;

	public String getQuestionId() {
		return questionId;
	}

	public void setQuestionId(String questionId) {
		this.questionId = questionId;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	public Double getQuestionScore() {
		return questionScore;
	}

	public void setQuestionScore(Double questionScore) {
		this.questionScore = questionScore;
	}

	public Integer getLimitedPlayTimes() {
		return limitedPlayTimes;
	}

	public void setLimitedPlayTimes(Integer limitedPlayTimes) {
		this.limitedPlayTimes = limitedPlayTimes;
	}

	public Integer getPlayedTimes() {
		return playedTimes;
	}

	public void setPlayedTimes(Integer playedTimes) {
		this.playedTimes = playedTimes;
	}

	public Long getTimeLimit() {
		return timeLimit;
	}

	public void setTimeLimit(Long timeLimit) {
		this.timeLimit = timeLimit;
	}

	public List<DefaultQuestionUnitWrapper> getQuestionUnitWrapperList() {
		return questionUnitWrapperList;
	}

	public void setQuestionUnitWrapperList(
			List<DefaultQuestionUnitWrapper> questionUnitWrapperList) {
		this.questionUnitWrapperList = questionUnitWrapperList;
	}

}
