package cn.com.qmth.examcloud.support.enums;

/**
 * @Description 考试过程
 * @Author lideyin
 * @Date 2020/8/20 15:26
 * @Version 1.0
 */
public enum ExamProcess {
    START("START", "开始考试"),
    IP_CHANGE("IP_CHANGE", "IP变动"),
    BREAK_OFF("BREAK_OFF", "考试中断"),
    CONTINUE("CONTINUE", "断点续考"),
    AUTO_HAND_IN("AUTO_HAND_IN", "服务端交卷"),
    MANUAL_HAND_IN("MANUAL_HAND_IN", "考生端交卷");
    private String code;
    private String desc;

    ExamProcess(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    /**
     * 考试过程代码
     * @return
     */
    public String getCode(){
        return this.code;
    }

    /**
     * 考试过程描述
     * @return
     */
    public String getDesc(){
        return this.desc;
    }
}
