package cn.com.qmth.examcloud.support.handler.richText;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import com.mysql.cj.util.StringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description 富文本处理器工厂类
 * @Author lideyin
 * @Date 2020/5/15 16:33
 * @Version 1.0
 */
@Deprecated
public class RichTextHandlerFactory {
    private static final Map<String,RichTextHandler> handlerMap=new HashMap<>();

    static {
        handlerMap.put("text",new HtmlTextHandler());
        handlerMap.put("image",new ImageTextHandler());
        handlerMap.put("audio",new AudioTextHandler());
    }

    /**
     * 根据类型获取实例
     * @param type 文本类型
     * @return
     */
    public static RichTextHandler getHandler(String type) {
        if (StringUtils.isNullOrEmpty(type)) {
            throw new StatusException("900101","参数type不允许为空");
        }

        //由于复合文处理类中有公共字段，所以必须是多例
        if (type.equals("complex")) {
            return new ComplexTextHandler();
        }

        if (!handlerMap.containsKey(type)) {
            throw new StatusException("900102","不支持的文本类型");
        }

        return handlerMap.get(type);
    }
}
