package cn.com.qmth.examcloud.support.redis;

/**
 * Redis key构建器接口
 *
 * @author WANGWEI
 * @date 2019年8月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface RedisKeyBuilder {

	@RedisKeyDefine(value = "网考考试会话", Prefix = "OE_SESSION")
	String examingSessionKey(Long studentId);

	@RedisKeyDefine(value = "考试活动时间", Prefix = "OE_ACTIVE")
	String examingActiveTimeKey(Long examRecordDataId);

	@RedisKeyDefine(value = "考试心跳", Prefix = "OE_HEARTBEAT")
	String examingHeartbeatKey(Long examRecordDataId);

	@RedisKeyDefine(value = "网考考试记录", Prefix = "OE_ERD")
	String examRecordDataKey(Long examRecordDataId);

	@RedisKeyDefine(value = "网考试卷结构", Prefix = "OE_PAPER")
	String studentPaperKey(Long examRecordDataId);

	@RedisKeyDefine(value = "网考作答", Prefix = "OE_ANSWER")
	String studentAnswerKey(Long examRecordDataId, Integer order);

	@RedisKeyDefine(value = "文件作答", Prefix = "OE_File_ANSWER")
	String studentFileAnswerKey(Long examRecordDataId, Integer order);

	@RedisKeyDefine(value = "考试控制属性", Prefix = "OE_BOSS")
	String examBossKey(Long examStudentId);

}
