package cn.com.qmth.examcloud.web.cache;

/**
 * 对象缓存
 *
 * @author WANGWEI
 * @date 2019年3月13日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 * @param <T>
 */
public interface ObjectCache<T> {

	/**
	 * 从缓存中获取
	 *
	 * @author WANGWEI
	 * @param keys
	 * @return
	 */
	T get(Object... keys);

	/**
	 * 删除缓存
	 *
	 * @author WANGWEI
	 * @param keys
	 */
	void remove(Object... keys);

	/**
	 * 刷新缓存
	 *
	 * @author WANGWEI
	 * @param keys
	 */
	void refresh(Object... keys);

	/**
	 * 从数据源（数据库,配置文件等）加载单个缓存项
	 *
	 * @author WANGWEI
	 * @param keys
	 * @return
	 */
	T loadFromResource(Object... keys);

}
