package cn.com.qmth.examcloud.web.cache;

import cn.com.qmth.examcloud.web.redis.RedisClient;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * 随机缓存版本控制
 *
 * @author WANGWEI
 * @date 2019年10月25日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class RandomCacheVersionHelper {

	private static RedisClient redisClient;

	private static RedisClient getRedisClient() {
		if (null == redisClient) {
			redisClient = SpringContextHolder.getBean(RedisClient.class);
		}
		return redisClient;
	}

	/**
	 * 设置版本
	 *
	 * @author WANGWEI
	 * @param c
	 * @param version
	 * @param timeout
	 */
	public static void setVersion(Class<? extends RandomCacheBean> c, String version, int timeout) {
		String key = "$_V_" + c.getCanonicalName();
		getRedisClient().set(key, version, timeout);
	}

	/**
	 * 获取版本
	 *
	 * @author WANGWEI
	 * @param c
	 * @param version
	 * @return
	 */
	public static String getVersion(Class<? extends RandomCacheBean> c, String version) {
		String key = "$_V_" + c.getCanonicalName();
		return getRedisClient().get(key, String.class);
	}

}
