package cn.com.qmth.examcloud.web.cloud;

import cn.com.qmth.examcloud.commons.exception.ExamCloudRuntimeException;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * AppSelf holder
 *
 * @author WANGWEI
 * @date 2019年2月21日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class AppSelfHolder {

	private static AppSelf appSelf;

	/**
	 * 获取
	 *
	 * @author WANGWEI
	 * @return
	 */
	public static AppSelf get() {
		if (null == appSelf) {
			appSelf = SpringContextHolder.getBean(AppSelf.class);
			if (null == appSelf) {
				throw new ExamCloudRuntimeException("no AppSelf");
			}
		}

		return appSelf;
	}

	/**
	 * 设置
	 *
	 * @author WANGWEI
	 * @param appSelf
	 */
	public static void set(AppSelf appSelf) {
		AppSelfHolder.appSelf = appSelf;
	}

}
