package cn.com.qmth.examcloud.web.config;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * 日志属性
 *
 * @author WANGWEI
 * @date 2019年3月20日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Component
@ConfigurationProperties("examcloud.web.log")
public class LogProperties {

	/**
	 * 是否记录正常相应信息
	 */
	private boolean normalResponseLogEnable = true;

	/**
	 * 正常响应信息json长度限制
	 */
	private int responseLogJsonMaxSize = 200;

	public boolean isNormalResponseLogEnable() {
		return normalResponseLogEnable;
	}

	public void setNormalResponseLogEnable(boolean normalResponseLogEnable) {
		this.normalResponseLogEnable = normalResponseLogEnable;
	}

	public int getResponseLogJsonMaxSize() {
		return responseLogJsonMaxSize;
	}

	public void setResponseLogJsonMaxSize(int responseLogJsonMaxSize) {
		this.responseLogJsonMaxSize = responseLogJsonMaxSize;
	}

}
