package cn.com.qmth.examcloud.web.filestorage;

import org.apache.commons.lang3.StringUtils;

import cn.com.qmth.examcloud.commons.exception.StatusException;

public class FileStorageHelper {
	private static String connector = "://";
	
	public static String getUpyunSiteOne(String path) {
		return FileStorageType.UPYUN.name().toLowerCase() +"-1"+ connector + path;
	}

	public static String getUrl(String domain, String path) {
		if (StringUtils.isBlank(domain)) {
			return null;
		}
		if (StringUtils.isBlank(path)) {
			return null;
		}
		if (path.startsWith("/")) {
			path = path.substring(1);
		}
		if (domain.endsWith("/")) {
			domain = domain.substring(0, domain.length());
		}
		return domain + "/" + path;
	}

	public static String getYunId(String path) {
		if (StringUtils.isBlank(path)) {
			return null;
		}
		if (path.indexOf(connector) == -1) {
			throw new StatusException("7001", "文件路径格式错误:" + path);
		}
		String hpath = path.substring(0, path.indexOf(connector));
		if (hpath.indexOf("-") == -1) {
			throw new StatusException("7002", "文件路径格式错误:" + path);
		}
		String yunId = hpath.substring(hpath.indexOf("-") + 1);
		if (StringUtils.isBlank(yunId)) {
			throw new StatusException("7003", "文件路径格式错误:" + path);
		}
		return yunId;
	}

	public static String getHead(String path) {
		if (StringUtils.isBlank(path)) {
			return null;
		}
		if (path.indexOf(connector) == -1) {
			throw new StatusException("8001", "文件路径格式错误:" + path);
		}
		String hpath = path.substring(0, path.indexOf(connector));
		if (hpath.indexOf("-") == -1) {
			throw new StatusException("8002", "文件路径格式错误:" + path);
		}
		String head = hpath.substring(0, hpath.indexOf("-"));
		if (StringUtils.isBlank(head)) {
			throw new StatusException("8003", "文件路径格式错误:" + path);
		}
		return head;
	}

	public static String getPath(String path) {
		if (StringUtils.isBlank(path)) {
			return null;
		}
		if (path.indexOf(connector) == -1) {
			throw new StatusException("9001", "文件路径格式错误:" + path);
		}
		String rpath = path.substring(path.indexOf(connector) + 3);
		if (StringUtils.isBlank(rpath)) {
			throw new StatusException("9002", "文件路径格式错误:" + path);
		}
		return rpath;
	}
}
