package cn.com.qmth.examcloud.web.jpa;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.EntityListeners;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;
import org.springframework.data.jpa.repository.Modifying;

/**
 * JPA 数据库实体父类
 *
 * @author WANGWEI
 * @date 2018年10月22日
 * @Copyright (c) 2018-2020 WANGWEI [QQ:522080330] All Rights Reserved.
 */
@MappedSuperclass
@EntityListeners(AuditingEntityListener.class)

public abstract class JpaEntity implements JsonSerializable {

	private static final long serialVersionUID = 1561273677157469875L;

	/**
	 * 更新时间
	 */
	@LastModifiedDate
	@Column(nullable = false)
	@Temporal(TemporalType.TIMESTAMP)
	private Date updateTime;

	/**
	 * 创建时间
	 */
	@CreatedDate
	@Column(nullable = false, updatable = false)
	@Temporal(TemporalType.TIMESTAMP)
	private Date creationTime;

	public Date getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}

	public Date getCreationTime() {
		return creationTime;
	}

	public void setCreationTime(Date creationTime) {
		this.creationTime = creationTime;
	}

}
