package cn.com.qmth.examcloud.web.support;

import java.util.Collections;
import java.util.concurrent.TimeUnit;

import org.apache.commons.lang3.RandomUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.util.DateUtil;
import cn.com.qmth.examcloud.commons.util.Util;

/**
 * examcloud controller
 *
 * @author WANGWEI
 * @date 2018年8月23日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
public class ExamCloudController {

	private static final Logger LOG = LoggerFactory.getLogger(ExamCloudController.class);

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.GET)
	public String get(@RequestParam(required = false) Boolean bug,
			@RequestParam(required = false) Integer elapsedTime) {
		if (null != bug && bug) {
			if (RandomUtils.nextBoolean()) {
				throw new RuntimeException("Ha Ha Ha ... ...");
			}
		}

		if (null != elapsedTime && 0 < elapsedTime && elapsedTime < 10000) {
			Util.sleep(TimeUnit.MILLISECONDS, elapsedTime);
		}
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.HEAD)
	public ResponseEntity<?> head() {
		return new ResponseEntity<Object>(HttpStatus.NO_CONTENT);
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.OPTIONS)
	public HttpEntity<?> options() {
		HttpHeaders headers = new HttpHeaders();
		headers.setAllow(Collections.singleton(HttpMethod.GET));
		return new ResponseEntity<Object>(headers, HttpStatus.OK);
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.POST)
	public String post() {
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.PUT)
	public String put() {
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.DELETE)
	public String delete() {
		return DateUtil.chinaNow();
	}

}
