package cn.com.qmth.examcloud.web.support;

import java.util.Map;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.google.common.collect.Maps;

/**
 * 运行时系统信息
 *
 * @author WANGWEI
 * @date 2018年7月4日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("runtime")
public class RuntimeController extends ControllerSupport {

	@Value("${spring.application.name}")
	private String application;

	@GetMapping
	public void getInfo() {
		Map<String, Object> infos = Maps.newLinkedHashMap();
		infos.put("应用名称", application.toUpperCase());

		infos.put("CPU个数", Runtime.getRuntime().availableProcessors());
		infos.put("虚拟机内存总量", Runtime.getRuntime().totalMemory());
		infos.put("虚拟机空闲内存量", Runtime.getRuntime().freeMemory());
		infos.put("虚拟机使用最大内存量", Runtime.getRuntime().maxMemory());

		ServletUtil.returnJson(infos, getResponse());
	}

}
